package com.company.hotchatcmdline;// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: mensagem.proto

public final class MensagemOuterClass {
  private MensagemOuterClass() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface MensagemOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Mensagem)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>required string sender = 1;</code>
     */
    boolean hasSender();
    /**
     * <code>required string sender = 1;</code>
     */
    String getSender();
    /**
     * <code>required string sender = 1;</code>
     */
    com.google.protobuf.ByteString
        getSenderBytes();

    /**
     * <code>required string date = 2;</code>
     */
    boolean hasDate();
    /**
     * <code>required string date = 2;</code>
     */
    String getDate();
    /**
     * <code>required string date = 2;</code>
     */
    com.google.protobuf.ByteString
        getDateBytes();

    /**
     * <code>required string time = 3;</code>
     */
    boolean hasTime();
    /**
     * <code>required string time = 3;</code>
     */
    String getTime();
    /**
     * <code>required string time = 3;</code>
     */
    com.google.protobuf.ByteString
        getTimeBytes();

    /**
     * <code>optional string group = 4;</code>
     */
    boolean hasGroup();
    /**
     * <code>optional string group = 4;</code>
     */
    String getGroup();
    /**
     * <code>optional string group = 4;</code>
     */
    com.google.protobuf.ByteString
        getGroupBytes();

    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    java.util.List<Mensagem.Conteudo>
        getContentList();
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    Mensagem.Conteudo getContent(int index);
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    int getContentCount();
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    java.util.List<? extends Mensagem.ConteudoOrBuilder>
        getContentOrBuilderList();
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    Mensagem.ConteudoOrBuilder getContentOrBuilder(
            int index);
  }
  /**
   * Protobuf type {@code Mensagem}
   */
  public  static final class Mensagem extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Mensagem)
      MensagemOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Mensagem.newBuilder() to construct.
    private Mensagem(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Mensagem() {
      sender_ = "";
      date_ = "";
      time_ = "";
      group_ = "";
      content_ = java.util.Collections.emptyList();
    }

    @Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Mensagem(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              com.google.protobuf.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000001;
              sender_ = bs;
              break;
            }
            case 18: {
              com.google.protobuf.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000002;
              date_ = bs;
              break;
            }
            case 26: {
              com.google.protobuf.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000004;
              time_ = bs;
              break;
            }
            case 34: {
              com.google.protobuf.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000008;
              group_ = bs;
              break;
            }
            case 42: {
              if (!((mutable_bitField0_ & 0x00000010) == 0x00000010)) {
                content_ = new java.util.ArrayList<Conteudo>();
                mutable_bitField0_ |= 0x00000010;
              }
              content_.add(
                  input.readMessage(Conteudo.PARSER, extensionRegistry));
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000010) == 0x00000010)) {
          content_ = java.util.Collections.unmodifiableList(content_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return MensagemOuterClass.internal_static_Mensagem_descriptor;
    }

    protected FieldAccessorTable
        internalGetFieldAccessorTable() {
      return MensagemOuterClass.internal_static_Mensagem_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              Mensagem.class, Builder.class);
    }

    public interface ConteudoOrBuilder extends
        // @@protoc_insertion_point(interface_extends:Mensagem.Conteudo)
        com.google.protobuf.MessageOrBuilder {

      /**
       * <code>optional string name = 1;</code>
       */
      boolean hasName();
      /**
       * <code>optional string name = 1;</code>
       */
      String getName();
      /**
       * <code>optional string name = 1;</code>
       */
      com.google.protobuf.ByteString
          getNameBytes();

      /**
       * <code>required string type = 2;</code>
       */
      boolean hasType();
      /**
       * <code>required string type = 2;</code>
       */
      String getType();
      /**
       * <code>required string type = 2;</code>
       */
      com.google.protobuf.ByteString
          getTypeBytes();

      /**
       * <code>required bytes content = 3;</code>
       */
      boolean hasContent();
      /**
       * <code>required bytes content = 3;</code>
       */
      com.google.protobuf.ByteString getContent();
    }
    /**
     * Protobuf type {@code Mensagem.Conteudo}
     */
    public  static final class Conteudo extends
        com.google.protobuf.GeneratedMessageV3 implements
        // @@protoc_insertion_point(message_implements:Mensagem.Conteudo)
        ConteudoOrBuilder {
    private static final long serialVersionUID = 0L;
      // Use Conteudo.newBuilder() to construct.
      private Conteudo(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
        super(builder);
      }
      private Conteudo() {
        name_ = "";
        type_ = "";
        content_ = com.google.protobuf.ByteString.EMPTY;
      }

      @Override
      public final com.google.protobuf.UnknownFieldSet
      getUnknownFields() {
        return this.unknownFields;
      }
      private Conteudo(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        this();
        int mutable_bitField0_ = 0;
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder();
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!parseUnknownField(
                    input, unknownFields, extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
              case 10: {
                com.google.protobuf.ByteString bs = input.readBytes();
                bitField0_ |= 0x00000001;
                name_ = bs;
                break;
              }
              case 18: {
                com.google.protobuf.ByteString bs = input.readBytes();
                bitField0_ |= 0x00000002;
                type_ = bs;
                break;
              }
              case 26: {
                bitField0_ |= 0x00000004;
                content_ = input.readBytes();
                break;
              }
            }
          }
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(this);
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(
              e).setUnfinishedMessage(this);
        } finally {
          this.unknownFields = unknownFields.build();
          makeExtensionsImmutable();
        }
      }
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return MensagemOuterClass.internal_static_Mensagem_Conteudo_descriptor;
      }

      protected FieldAccessorTable
          internalGetFieldAccessorTable() {
        return MensagemOuterClass.internal_static_Mensagem_Conteudo_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                Conteudo.class, Builder.class);
      }

      private int bitField0_;
      public static final int NAME_FIELD_NUMBER = 1;
      private volatile Object name_;
      /**
       * <code>optional string name = 1;</code>
       */
      public boolean hasName() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string name = 1;</code>
       */
      public String getName() {
        Object ref = name_;
        if (ref instanceof String) {
          return (String) ref;
        } else {
          com.google.protobuf.ByteString bs = 
              (com.google.protobuf.ByteString) ref;
          String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            name_ = s;
          }
          return s;
        }
      }
      /**
       * <code>optional string name = 1;</code>
       */
      public com.google.protobuf.ByteString
          getNameBytes() {
        Object ref = name_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          name_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }

      public static final int TYPE_FIELD_NUMBER = 2;
      private volatile Object type_;
      /**
       * <code>required string type = 2;</code>
       */
      public boolean hasType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required string type = 2;</code>
       */
      public String getType() {
        Object ref = type_;
        if (ref instanceof String) {
          return (String) ref;
        } else {
          com.google.protobuf.ByteString bs = 
              (com.google.protobuf.ByteString) ref;
          String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            type_ = s;
          }
          return s;
        }
      }
      /**
       * <code>required string type = 2;</code>
       */
      public com.google.protobuf.ByteString
          getTypeBytes() {
        Object ref = type_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          type_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }

      public static final int CONTENT_FIELD_NUMBER = 3;
      private com.google.protobuf.ByteString content_;
      /**
       * <code>required bytes content = 3;</code>
       */
      public boolean hasContent() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>required bytes content = 3;</code>
       */
      public com.google.protobuf.ByteString getContent() {
        return content_;
      }

      private byte memoizedIsInitialized = -1;
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized == 1) return true;
        if (isInitialized == 0) return false;

        if (!hasType()) {
          memoizedIsInitialized = 0;
          return false;
        }
        if (!hasContent()) {
          memoizedIsInitialized = 0;
          return false;
        }
        memoizedIsInitialized = 1;
        return true;
      }

      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          com.google.protobuf.GeneratedMessageV3.writeString(output, 1, name_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          com.google.protobuf.GeneratedMessageV3.writeString(output, 2, type_);
        }
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          output.writeBytes(3, content_);
        }
        unknownFields.writeTo(output);
      }

      public int getSerializedSize() {
        int size = memoizedSize;
        if (size != -1) return size;

        size = 0;
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, name_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, type_);
        }
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBytesSize(3, content_);
        }
        size += unknownFields.getSerializedSize();
        memoizedSize = size;
        return size;
      }

      @Override
      public boolean equals(final Object obj) {
        if (obj == this) {
         return true;
        }
        if (!(obj instanceof Conteudo)) {
          return super.equals(obj);
        }
        Conteudo other = (Conteudo) obj;

        boolean result = true;
        result = result && (hasName() == other.hasName());
        if (hasName()) {
          result = result && getName()
              .equals(other.getName());
        }
        result = result && (hasType() == other.hasType());
        if (hasType()) {
          result = result && getType()
              .equals(other.getType());
        }
        result = result && (hasContent() == other.hasContent());
        if (hasContent()) {
          result = result && getContent()
              .equals(other.getContent());
        }
        result = result && unknownFields.equals(other.unknownFields);
        return result;
      }

      @Override
      public int hashCode() {
        if (memoizedHashCode != 0) {
          return memoizedHashCode;
        }
        int hash = 41;
        hash = (19 * hash) + getDescriptor().hashCode();
        if (hasName()) {
          hash = (37 * hash) + NAME_FIELD_NUMBER;
          hash = (53 * hash) + getName().hashCode();
        }
        if (hasType()) {
          hash = (37 * hash) + TYPE_FIELD_NUMBER;
          hash = (53 * hash) + getType().hashCode();
        }
        if (hasContent()) {
          hash = (37 * hash) + CONTENT_FIELD_NUMBER;
          hash = (53 * hash) + getContent().hashCode();
        }
        hash = (29 * hash) + unknownFields.hashCode();
        memoizedHashCode = hash;
        return hash;
      }

      public static Conteudo parseFrom(
          java.nio.ByteBuffer data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static Conteudo parseFrom(
          java.nio.ByteBuffer data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static Conteudo parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static Conteudo parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static Conteudo parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static Conteudo parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static Conteudo parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
            .parseWithIOException(PARSER, input);
      }
      public static Conteudo parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
            .parseWithIOException(PARSER, input, extensionRegistry);
      }
      public static Conteudo parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
            .parseDelimitedWithIOException(PARSER, input);
      }
      public static Conteudo parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
            .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
      }
      public static Conteudo parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
            .parseWithIOException(PARSER, input);
      }
      public static Conteudo parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
            .parseWithIOException(PARSER, input, extensionRegistry);
      }

      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder() {
        return DEFAULT_INSTANCE.toBuilder();
      }
      public static Builder newBuilder(Conteudo prototype) {
        return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() {
        return this == DEFAULT_INSTANCE
            ? new Builder() : new Builder().mergeFrom(this);
      }

      @Override
      protected Builder newBuilderForType(
          BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      /**
       * Protobuf type {@code Mensagem.Conteudo}
       */
      public static final class Builder extends
          com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
          // @@protoc_insertion_point(builder_implements:Mensagem.Conteudo)
          ConteudoOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return MensagemOuterClass.internal_static_Mensagem_Conteudo_descriptor;
        }

        protected FieldAccessorTable
            internalGetFieldAccessorTable() {
          return MensagemOuterClass.internal_static_Mensagem_Conteudo_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  Conteudo.class, Builder.class);
        }

        // Construct using MensagemOuterClass.Mensagem.Conteudo.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }

        private Builder(
            BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (com.google.protobuf.GeneratedMessageV3
                  .alwaysUseFieldBuilders) {
          }
        }
        public Builder clear() {
          super.clear();
          name_ = "";
          bitField0_ = (bitField0_ & ~0x00000001);
          type_ = "";
          bitField0_ = (bitField0_ & ~0x00000002);
          content_ = com.google.protobuf.ByteString.EMPTY;
          bitField0_ = (bitField0_ & ~0x00000004);
          return this;
        }

        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return MensagemOuterClass.internal_static_Mensagem_Conteudo_descriptor;
        }

        public Conteudo getDefaultInstanceForType() {
          return Conteudo.getDefaultInstance();
        }

        public Conteudo build() {
          Conteudo result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }

        public Conteudo buildPartial() {
          Conteudo result = new Conteudo(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
            to_bitField0_ |= 0x00000001;
          }
          result.name_ = name_;
          if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
            to_bitField0_ |= 0x00000002;
          }
          result.type_ = type_;
          if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
            to_bitField0_ |= 0x00000004;
          }
          result.content_ = content_;
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }

        public Builder clone() {
          return (Builder) super.clone();
        }
        public Builder setField(
            com.google.protobuf.Descriptors.FieldDescriptor field,
            Object value) {
          return (Builder) super.setField(field, value);
        }
        public Builder clearField(
            com.google.protobuf.Descriptors.FieldDescriptor field) {
          return (Builder) super.clearField(field);
        }
        public Builder clearOneof(
            com.google.protobuf.Descriptors.OneofDescriptor oneof) {
          return (Builder) super.clearOneof(oneof);
        }
        public Builder setRepeatedField(
            com.google.protobuf.Descriptors.FieldDescriptor field,
            int index, Object value) {
          return (Builder) super.setRepeatedField(field, index, value);
        }
        public Builder addRepeatedField(
            com.google.protobuf.Descriptors.FieldDescriptor field,
            Object value) {
          return (Builder) super.addRepeatedField(field, value);
        }
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof Conteudo) {
            return mergeFrom((Conteudo)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }

        public Builder mergeFrom(Conteudo other) {
          if (other == Conteudo.getDefaultInstance()) return this;
          if (other.hasName()) {
            bitField0_ |= 0x00000001;
            name_ = other.name_;
            onChanged();
          }
          if (other.hasType()) {
            bitField0_ |= 0x00000002;
            type_ = other.type_;
            onChanged();
          }
          if (other.hasContent()) {
            setContent(other.getContent());
          }
          this.mergeUnknownFields(other.unknownFields);
          onChanged();
          return this;
        }

        public final boolean isInitialized() {
          if (!hasType()) {
            return false;
          }
          if (!hasContent()) {
            return false;
          }
          return true;
        }

        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          Conteudo parsedMessage = null;
          try {
            parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            parsedMessage = (Conteudo) e.getUnfinishedMessage();
            throw e.unwrapIOException();
          } finally {
            if (parsedMessage != null) {
              mergeFrom(parsedMessage);
            }
          }
          return this;
        }
        private int bitField0_;

        private Object name_ = "";
        /**
         * <code>optional string name = 1;</code>
         */
        public boolean hasName() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>optional string name = 1;</code>
         */
        public String getName() {
          Object ref = name_;
          if (!(ref instanceof String)) {
            com.google.protobuf.ByteString bs =
                (com.google.protobuf.ByteString) ref;
            String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              name_ = s;
            }
            return s;
          } else {
            return (String) ref;
          }
        }
        /**
         * <code>optional string name = 1;</code>
         */
        public com.google.protobuf.ByteString
            getNameBytes() {
          Object ref = name_;
          if (ref instanceof String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (String) ref);
            name_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }
        /**
         * <code>optional string name = 1;</code>
         */
        public Builder setName(
            String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
          name_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>optional string name = 1;</code>
         */
        public Builder clearName() {
          bitField0_ = (bitField0_ & ~0x00000001);
          name_ = getDefaultInstance().getName();
          onChanged();
          return this;
        }
        /**
         * <code>optional string name = 1;</code>
         */
        public Builder setNameBytes(
            com.google.protobuf.ByteString value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
          name_ = value;
          onChanged();
          return this;
        }

        private Object type_ = "";
        /**
         * <code>required string type = 2;</code>
         */
        public boolean hasType() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        /**
         * <code>required string type = 2;</code>
         */
        public String getType() {
          Object ref = type_;
          if (!(ref instanceof String)) {
            com.google.protobuf.ByteString bs =
                (com.google.protobuf.ByteString) ref;
            String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              type_ = s;
            }
            return s;
          } else {
            return (String) ref;
          }
        }
        /**
         * <code>required string type = 2;</code>
         */
        public com.google.protobuf.ByteString
            getTypeBytes() {
          Object ref = type_;
          if (ref instanceof String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (String) ref);
            type_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }
        /**
         * <code>required string type = 2;</code>
         */
        public Builder setType(
            String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
          type_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>required string type = 2;</code>
         */
        public Builder clearType() {
          bitField0_ = (bitField0_ & ~0x00000002);
          type_ = getDefaultInstance().getType();
          onChanged();
          return this;
        }
        /**
         * <code>required string type = 2;</code>
         */
        public Builder setTypeBytes(
            com.google.protobuf.ByteString value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
          type_ = value;
          onChanged();
          return this;
        }

        private com.google.protobuf.ByteString content_ = com.google.protobuf.ByteString.EMPTY;
        /**
         * <code>required bytes content = 3;</code>
         */
        public boolean hasContent() {
          return ((bitField0_ & 0x00000004) == 0x00000004);
        }
        /**
         * <code>required bytes content = 3;</code>
         */
        public com.google.protobuf.ByteString getContent() {
          return content_;
        }
        /**
         * <code>required bytes content = 3;</code>
         */
        public Builder setContent(com.google.protobuf.ByteString value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
          content_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>required bytes content = 3;</code>
         */
        public Builder clearContent() {
          bitField0_ = (bitField0_ & ~0x00000004);
          content_ = getDefaultInstance().getContent();
          onChanged();
          return this;
        }
        public final Builder setUnknownFields(
            final com.google.protobuf.UnknownFieldSet unknownFields) {
          return super.setUnknownFields(unknownFields);
        }

        public final Builder mergeUnknownFields(
            final com.google.protobuf.UnknownFieldSet unknownFields) {
          return super.mergeUnknownFields(unknownFields);
        }


        // @@protoc_insertion_point(builder_scope:Mensagem.Conteudo)
      }

      // @@protoc_insertion_point(class_scope:Mensagem.Conteudo)
      private static final Conteudo DEFAULT_INSTANCE;
      static {
        DEFAULT_INSTANCE = new Conteudo();
      }

      public static Conteudo getDefaultInstance() {
        return DEFAULT_INSTANCE;
      }

      @Deprecated public static final com.google.protobuf.Parser<Conteudo>
          PARSER = new com.google.protobuf.AbstractParser<Conteudo>() {
        public Conteudo parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
            return new Conteudo(input, extensionRegistry);
        }
      };

      public static com.google.protobuf.Parser<Conteudo> parser() {
        return PARSER;
      }

      @Override
      public com.google.protobuf.Parser<Conteudo> getParserForType() {
        return PARSER;
      }

      public Conteudo getDefaultInstanceForType() {
        return DEFAULT_INSTANCE;
      }

    }

    private int bitField0_;
    public static final int SENDER_FIELD_NUMBER = 1;
    private volatile Object sender_;
    /**
     * <code>required string sender = 1;</code>
     */
    public boolean hasSender() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required string sender = 1;</code>
     */
    public String getSender() {
      Object ref = sender_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          sender_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string sender = 1;</code>
     */
    public com.google.protobuf.ByteString
        getSenderBytes() {
      Object ref = sender_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        sender_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int DATE_FIELD_NUMBER = 2;
    private volatile Object date_;
    /**
     * <code>required string date = 2;</code>
     */
    public boolean hasDate() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>required string date = 2;</code>
     */
    public String getDate() {
      Object ref = date_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          date_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string date = 2;</code>
     */
    public com.google.protobuf.ByteString
        getDateBytes() {
      Object ref = date_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        date_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int TIME_FIELD_NUMBER = 3;
    private volatile Object time_;
    /**
     * <code>required string time = 3;</code>
     */
    public boolean hasTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>required string time = 3;</code>
     */
    public String getTime() {
      Object ref = time_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          time_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string time = 3;</code>
     */
    public com.google.protobuf.ByteString
        getTimeBytes() {
      Object ref = time_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        time_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int GROUP_FIELD_NUMBER = 4;
    private volatile Object group_;
    /**
     * <code>optional string group = 4;</code>
     */
    public boolean hasGroup() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional string group = 4;</code>
     */
    public String getGroup() {
      Object ref = group_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          group_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string group = 4;</code>
     */
    public com.google.protobuf.ByteString
        getGroupBytes() {
      Object ref = group_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        group_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int CONTENT_FIELD_NUMBER = 5;
    private java.util.List<Conteudo> content_;
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    public java.util.List<Conteudo> getContentList() {
      return content_;
    }
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    public java.util.List<? extends ConteudoOrBuilder>
        getContentOrBuilderList() {
      return content_;
    }
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    public int getContentCount() {
      return content_.size();
    }
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    public Conteudo getContent(int index) {
      return content_.get(index);
    }
    /**
     * <code>repeated .Mensagem.Conteudo content = 5;</code>
     */
    public ConteudoOrBuilder getContentOrBuilder(
        int index) {
      return content_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasSender()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasDate()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasTime()) {
        memoizedIsInitialized = 0;
        return false;
      }
      for (int i = 0; i < getContentCount(); i++) {
        if (!getContent(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, sender_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, date_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 3, time_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 4, group_);
      }
      for (int i = 0; i < content_.size(); i++) {
        output.writeMessage(5, content_.get(i));
      }
      unknownFields.writeTo(output);
    }

    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, sender_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, date_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, time_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(4, group_);
      }
      for (int i = 0; i < content_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(5, content_.get(i));
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @Override
    public boolean equals(final Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof Mensagem)) {
        return super.equals(obj);
      }
      Mensagem other = (Mensagem) obj;

      boolean result = true;
      result = result && (hasSender() == other.hasSender());
      if (hasSender()) {
        result = result && getSender()
            .equals(other.getSender());
      }
      result = result && (hasDate() == other.hasDate());
      if (hasDate()) {
        result = result && getDate()
            .equals(other.getDate());
      }
      result = result && (hasTime() == other.hasTime());
      if (hasTime()) {
        result = result && getTime()
            .equals(other.getTime());
      }
      result = result && (hasGroup() == other.hasGroup());
      if (hasGroup()) {
        result = result && getGroup()
            .equals(other.getGroup());
      }
      result = result && getContentList()
          .equals(other.getContentList());
      result = result && unknownFields.equals(other.unknownFields);
      return result;
    }

    @Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasSender()) {
        hash = (37 * hash) + SENDER_FIELD_NUMBER;
        hash = (53 * hash) + getSender().hashCode();
      }
      if (hasDate()) {
        hash = (37 * hash) + DATE_FIELD_NUMBER;
        hash = (53 * hash) + getDate().hashCode();
      }
      if (hasTime()) {
        hash = (37 * hash) + TIME_FIELD_NUMBER;
        hash = (53 * hash) + getTime().hashCode();
      }
      if (hasGroup()) {
        hash = (37 * hash) + GROUP_FIELD_NUMBER;
        hash = (53 * hash) + getGroup().hashCode();
      }
      if (getContentCount() > 0) {
        hash = (37 * hash) + CONTENT_FIELD_NUMBER;
        hash = (53 * hash) + getContentList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static Mensagem parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static Mensagem parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static Mensagem parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static Mensagem parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static Mensagem parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static Mensagem parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static Mensagem parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static Mensagem parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static Mensagem parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static Mensagem parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static Mensagem parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static Mensagem parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(Mensagem prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @Override
    protected Builder newBuilderForType(
        BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code Mensagem}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Mensagem)
        MensagemOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return MensagemOuterClass.internal_static_Mensagem_descriptor;
      }

      protected FieldAccessorTable
          internalGetFieldAccessorTable() {
        return MensagemOuterClass.internal_static_Mensagem_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                Mensagem.class, Builder.class);
      }

      // Construct using MensagemOuterClass.Mensagem.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getContentFieldBuilder();
        }
      }
      public Builder clear() {
        super.clear();
        sender_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        date_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        time_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        group_ = "";
        bitField0_ = (bitField0_ & ~0x00000008);
        if (contentBuilder_ == null) {
          content_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
        } else {
          contentBuilder_.clear();
        }
        return this;
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return MensagemOuterClass.internal_static_Mensagem_descriptor;
      }

      public Mensagem getDefaultInstanceForType() {
        return Mensagem.getDefaultInstance();
      }

      public Mensagem build() {
        Mensagem result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public Mensagem buildPartial() {
        Mensagem result = new Mensagem(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sender_ = sender_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.date_ = date_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.time_ = time_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.group_ = group_;
        if (contentBuilder_ == null) {
          if (((bitField0_ & 0x00000010) == 0x00000010)) {
            content_ = java.util.Collections.unmodifiableList(content_);
            bitField0_ = (bitField0_ & ~0x00000010);
          }
          result.content_ = content_;
        } else {
          result.content_ = contentBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder clone() {
        return (Builder) super.clone();
      }
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.setField(field, value);
      }
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return (Builder) super.clearField(field);
      }
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return (Builder) super.clearOneof(oneof);
      }
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, Object value) {
        return (Builder) super.setRepeatedField(field, index, value);
      }
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          Object value) {
        return (Builder) super.addRepeatedField(field, value);
      }
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof Mensagem) {
          return mergeFrom((Mensagem)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(Mensagem other) {
        if (other == Mensagem.getDefaultInstance()) return this;
        if (other.hasSender()) {
          bitField0_ |= 0x00000001;
          sender_ = other.sender_;
          onChanged();
        }
        if (other.hasDate()) {
          bitField0_ |= 0x00000002;
          date_ = other.date_;
          onChanged();
        }
        if (other.hasTime()) {
          bitField0_ |= 0x00000004;
          time_ = other.time_;
          onChanged();
        }
        if (other.hasGroup()) {
          bitField0_ |= 0x00000008;
          group_ = other.group_;
          onChanged();
        }
        if (contentBuilder_ == null) {
          if (!other.content_.isEmpty()) {
            if (content_.isEmpty()) {
              content_ = other.content_;
              bitField0_ = (bitField0_ & ~0x00000010);
            } else {
              ensureContentIsMutable();
              content_.addAll(other.content_);
            }
            onChanged();
          }
        } else {
          if (!other.content_.isEmpty()) {
            if (contentBuilder_.isEmpty()) {
              contentBuilder_.dispose();
              contentBuilder_ = null;
              content_ = other.content_;
              bitField0_ = (bitField0_ & ~0x00000010);
              contentBuilder_ = 
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getContentFieldBuilder() : null;
            } else {
              contentBuilder_.addAllMessages(other.content_);
            }
          }
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      public final boolean isInitialized() {
        if (!hasSender()) {
          return false;
        }
        if (!hasDate()) {
          return false;
        }
        if (!hasTime()) {
          return false;
        }
        for (int i = 0; i < getContentCount(); i++) {
          if (!getContent(i).isInitialized()) {
            return false;
          }
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Mensagem parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (Mensagem) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private Object sender_ = "";
      /**
       * <code>required string sender = 1;</code>
       */
      public boolean hasSender() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required string sender = 1;</code>
       */
      public String getSender() {
        Object ref = sender_;
        if (!(ref instanceof String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            sender_ = s;
          }
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>required string sender = 1;</code>
       */
      public com.google.protobuf.ByteString
          getSenderBytes() {
        Object ref = sender_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          sender_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>required string sender = 1;</code>
       */
      public Builder setSender(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        sender_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string sender = 1;</code>
       */
      public Builder clearSender() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sender_ = getDefaultInstance().getSender();
        onChanged();
        return this;
      }
      /**
       * <code>required string sender = 1;</code>
       */
      public Builder setSenderBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        sender_ = value;
        onChanged();
        return this;
      }

      private Object date_ = "";
      /**
       * <code>required string date = 2;</code>
       */
      public boolean hasDate() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required string date = 2;</code>
       */
      public String getDate() {
        Object ref = date_;
        if (!(ref instanceof String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            date_ = s;
          }
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>required string date = 2;</code>
       */
      public com.google.protobuf.ByteString
          getDateBytes() {
        Object ref = date_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          date_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>required string date = 2;</code>
       */
      public Builder setDate(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        date_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string date = 2;</code>
       */
      public Builder clearDate() {
        bitField0_ = (bitField0_ & ~0x00000002);
        date_ = getDefaultInstance().getDate();
        onChanged();
        return this;
      }
      /**
       * <code>required string date = 2;</code>
       */
      public Builder setDateBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        date_ = value;
        onChanged();
        return this;
      }

      private Object time_ = "";
      /**
       * <code>required string time = 3;</code>
       */
      public boolean hasTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>required string time = 3;</code>
       */
      public String getTime() {
        Object ref = time_;
        if (!(ref instanceof String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            time_ = s;
          }
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>required string time = 3;</code>
       */
      public com.google.protobuf.ByteString
          getTimeBytes() {
        Object ref = time_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          time_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>required string time = 3;</code>
       */
      public Builder setTime(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        time_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string time = 3;</code>
       */
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        time_ = getDefaultInstance().getTime();
        onChanged();
        return this;
      }
      /**
       * <code>required string time = 3;</code>
       */
      public Builder setTimeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        time_ = value;
        onChanged();
        return this;
      }

      private Object group_ = "";
      /**
       * <code>optional string group = 4;</code>
       */
      public boolean hasGroup() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional string group = 4;</code>
       */
      public String getGroup() {
        Object ref = group_;
        if (!(ref instanceof String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            group_ = s;
          }
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string group = 4;</code>
       */
      public com.google.protobuf.ByteString
          getGroupBytes() {
        Object ref = group_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          group_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string group = 4;</code>
       */
      public Builder setGroup(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        group_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string group = 4;</code>
       */
      public Builder clearGroup() {
        bitField0_ = (bitField0_ & ~0x00000008);
        group_ = getDefaultInstance().getGroup();
        onChanged();
        return this;
      }
      /**
       * <code>optional string group = 4;</code>
       */
      public Builder setGroupBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        group_ = value;
        onChanged();
        return this;
      }

      private java.util.List<Conteudo> content_ =
        java.util.Collections.emptyList();
      private void ensureContentIsMutable() {
        if (!((bitField0_ & 0x00000010) == 0x00000010)) {
          content_ = new java.util.ArrayList<Conteudo>(content_);
          bitField0_ |= 0x00000010;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilderV3<
          Conteudo, Conteudo.Builder, ConteudoOrBuilder> contentBuilder_;

      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public java.util.List<Conteudo> getContentList() {
        if (contentBuilder_ == null) {
          return java.util.Collections.unmodifiableList(content_);
        } else {
          return contentBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public int getContentCount() {
        if (contentBuilder_ == null) {
          return content_.size();
        } else {
          return contentBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Conteudo getContent(int index) {
        if (contentBuilder_ == null) {
          return content_.get(index);
        } else {
          return contentBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder setContent(
          int index, Conteudo value) {
        if (contentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureContentIsMutable();
          content_.set(index, value);
          onChanged();
        } else {
          contentBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder setContent(
          int index, Conteudo.Builder builderForValue) {
        if (contentBuilder_ == null) {
          ensureContentIsMutable();
          content_.set(index, builderForValue.build());
          onChanged();
        } else {
          contentBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder addContent(Conteudo value) {
        if (contentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureContentIsMutable();
          content_.add(value);
          onChanged();
        } else {
          contentBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder addContent(
          int index, Conteudo value) {
        if (contentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureContentIsMutable();
          content_.add(index, value);
          onChanged();
        } else {
          contentBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder addContent(
          Conteudo.Builder builderForValue) {
        if (contentBuilder_ == null) {
          ensureContentIsMutable();
          content_.add(builderForValue.build());
          onChanged();
        } else {
          contentBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder addContent(
          int index, Conteudo.Builder builderForValue) {
        if (contentBuilder_ == null) {
          ensureContentIsMutable();
          content_.add(index, builderForValue.build());
          onChanged();
        } else {
          contentBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder addAllContent(
          Iterable<? extends Conteudo> values) {
        if (contentBuilder_ == null) {
          ensureContentIsMutable();
          com.google.protobuf.AbstractMessageLite.Builder.addAll(
              values, content_);
          onChanged();
        } else {
          contentBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder clearContent() {
        if (contentBuilder_ == null) {
          content_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
          onChanged();
        } else {
          contentBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Builder removeContent(int index) {
        if (contentBuilder_ == null) {
          ensureContentIsMutable();
          content_.remove(index);
          onChanged();
        } else {
          contentBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Conteudo.Builder getContentBuilder(
          int index) {
        return getContentFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public ConteudoOrBuilder getContentOrBuilder(
          int index) {
        if (contentBuilder_ == null) {
          return content_.get(index);  } else {
          return contentBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public java.util.List<? extends ConteudoOrBuilder>
           getContentOrBuilderList() {
        if (contentBuilder_ != null) {
          return contentBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(content_);
        }
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Conteudo.Builder addContentBuilder() {
        return getContentFieldBuilder().addBuilder(
            Conteudo.getDefaultInstance());
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public Conteudo.Builder addContentBuilder(
          int index) {
        return getContentFieldBuilder().addBuilder(
            index, Conteudo.getDefaultInstance());
      }
      /**
       * <code>repeated .Mensagem.Conteudo content = 5;</code>
       */
      public java.util.List<Conteudo.Builder>
           getContentBuilderList() {
        return getContentFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilderV3<
          Conteudo, Conteudo.Builder, ConteudoOrBuilder>
          getContentFieldBuilder() {
        if (contentBuilder_ == null) {
          contentBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
              Conteudo, Conteudo.Builder, ConteudoOrBuilder>(
                  content_,
                  ((bitField0_ & 0x00000010) == 0x00000010),
                  getParentForChildren(),
                  isClean());
          content_ = null;
        }
        return contentBuilder_;
      }
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Mensagem)
    }

    // @@protoc_insertion_point(class_scope:Mensagem)
    private static final Mensagem DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new Mensagem();
    }

    public static Mensagem getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @Deprecated public static final com.google.protobuf.Parser<Mensagem>
        PARSER = new com.google.protobuf.AbstractParser<Mensagem>() {
      public Mensagem parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
          return new Mensagem(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<Mensagem> parser() {
      return PARSER;
    }

    @Override
    public com.google.protobuf.Parser<Mensagem> getParserForType() {
      return PARSER;
    }

    public Mensagem getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_Mensagem_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_Mensagem_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_Mensagem_Conteudo_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_Mensagem_Conteudo_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    String[] descriptorData = {
      "\n\016mensagem.proto\"\243\001\n\010Mensagem\022\016\n\006sender\030" +
      "\001 \002(\t\022\014\n\004date\030\002 \002(\t\022\014\n\004time\030\003 \002(\t\022\r\n\005gro" +
      "up\030\004 \001(\t\022#\n\007content\030\005 \003(\0132\022.Mensagem.Con" +
      "teudo\0327\n\010Conteudo\022\014\n\004name\030\001 \001(\t\022\014\n\004type\030" +
      "\002 \002(\t\022\017\n\007content\030\003 \002(\014"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
        new com.google.protobuf.Descriptors.FileDescriptor.    InternalDescriptorAssigner() {
          public com.google.protobuf.ExtensionRegistry assignDescriptors(
              com.google.protobuf.Descriptors.FileDescriptor root) {
            descriptor = root;
            return null;
          }
        };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
    internal_static_Mensagem_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_Mensagem_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Mensagem_descriptor,
        new String[] { "Sender", "Date", "Time", "Group", "Content", });
    internal_static_Mensagem_Conteudo_descriptor =
      internal_static_Mensagem_descriptor.getNestedTypes().get(0);
    internal_static_Mensagem_Conteudo_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Mensagem_Conteudo_descriptor,
        new String[] { "Name", "Type", "Content", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
